"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});

var _extends = Object.assign || function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; };

var _createClass = function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; }();

var _button;

var _react = require("react");

var _react2 = _interopRequireDefault(_react);

var _Fade = require("@material-ui/core/Fade");

var _Fade2 = _interopRequireDefault(_Fade);

var _Slide = require("@material-ui/core/Slide");

var _Slide2 = _interopRequireDefault(_Slide);

var _IconButton = require("@material-ui/core/IconButton");

var _IconButton2 = _interopRequireDefault(_IconButton);

var _styles = require("@material-ui/core/styles");

var _autoBind = require("auto-bind");

var _autoBind2 = _interopRequireDefault(_autoBind);

var _FiberManualRecord = require("@material-ui/icons/FiberManualRecord");

var _FiberManualRecord2 = _interopRequireDefault(_FiberManualRecord);

var _NavigateBefore = require("@material-ui/icons/NavigateBefore");

var _NavigateBefore2 = _interopRequireDefault(_NavigateBefore);

var _NavigateNext = require("@material-ui/icons/NavigateNext");

var _NavigateNext2 = _interopRequireDefault(_NavigateNext);

var _reactSwipeable = require("react-swipeable");

var _Button = require("@material-ui/core/Button");

var _Button2 = _interopRequireDefault(_Button);

var _FastForward = require("@material-ui/icons/FastForward");

var _FastForward2 = _interopRequireDefault(_FastForward);

var _FastRewind = require("@material-ui/icons/FastRewind");

var _FastRewind2 = _interopRequireDefault(_FastRewind);

var _PlayArrow = require("@material-ui/icons/PlayArrow");

var _PlayArrow2 = _interopRequireDefault(_PlayArrow);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _possibleConstructorReturn(self, call) { if (!self) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return call && (typeof call === "object" || typeof call === "function") ? call : self; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function, not " + typeof superClass); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, enumerable: false, writable: true, configurable: true } }); if (superClass) Object.setPrototypeOf ? Object.setPrototypeOf(subClass, superClass) : subClass.__proto__ = superClass; }

function _defineProperty(obj, key, value) { if (key in obj) { Object.defineProperty(obj, key, { value: value, enumerable: true, configurable: true, writable: true }); } else { obj[key] = value; } return obj; }

var styles = {
  root: {
    // position: "relative",
    overflow: "hidden",
    backgroundColor: "#e0e0e0",
    padding: "1rem"
  },
  container: {
    position: "relative"
  },
  indicators: {
    width: "100%",
    marginTop: "10px",
    textAlign: "center"
  },
  indicator: {
    fontSize: "15px",
    cursor: "pointer",
    transition: "200ms",
    color: "#afafaf",
    "&:hover": {
      color: "#1f1f1f"
    },
    "&:active": {
      color: "#1f1f1f"
    }
  },
  active: {
    color: "#494949"
  },
  buttonWrapper: {
    position: "absolute",
    height: "100px",
    margin: 0,
    backgroundColor: "transparent",
    top: "0px"
  },
  fullHeightHoverWrapper: {
    height: "calc(10% - 20px - 10px) !important",
    top: "-10% !important"
  },
  button: (_button = {
    margin: "0 10px",
    position: "relative",
    top: "0%",
    backgroundColor: "#e0e0e0"
  }, _defineProperty(_button, "top", "0px"), _defineProperty(_button, "color", "white"), _defineProperty(_button, "fontSize", "30px"), _defineProperty(_button, "transition", "200ms"), _defineProperty(_button, "cursor", "pointer"), _defineProperty(_button, "&:hover", {
    opacity: "1 !important"
  }), _button),
  fullHeightHoverButton: {
    top: "calc(50% - 20px) !important"
  },
  playIconReversed: {
    transform: "rotate(180deg)"
  },

  buttonVisible: {
    opacity: "0.6"
  },
  buttonHidden: {
    opacity: "0"
  },
  next: {
    right: -45
  },
  prev: {
    left: -45
  },
  ff: {
    right: -82
  },
  rew: {
    left: -82
  }
};

var sanitizeProps = function sanitizeProps(props) {
  var animation = props.animation !== undefined ? props.animation : "fade";
  var timeout = props.timeout !== undefined ? props.timeout : animation === "fade" ? 500 : 200;

  return {
    children: props.children ? props.children : [],
    index: props.index !== undefined ? props.index : 0,
    strictIndexing: props.strictIndexing !== undefined ? props.strictIndexing : true,
    autoPlay: props.autoPlay !== undefined ? props.autoPlay : true,
    interval: props.interval !== undefined ? props.interval : 4000,
    indicators: props.indicators !== undefined ? props.indicators : true,
    navButtonsAlwaysInvisible: props.navButtonsAlwaysInvisible !== undefined ? props.navButtonsAlwaysInvisible : false,
    navButtonsAlwaysVisible: props.navButtonsAlwaysVisible !== undefined ? props.navButtonsAlwaysVisible : false,
    animation: animation,
    timeout: timeout,
    fullHeightHover: props.fullHeightHover !== undefined ? props.fullHeightHover : true,
    indicatorContainerProps: props.indicatorContainerProps,
    indicatorProps: props.indicatorProps,
    activeIndicatorProps: props.activeIndicatorProps,
    onChange: props.onChange !== undefined ? props.onChange : function () {},
    changeOnFirstRender: props.changeOnFirstRender !== undefined ? props.changeOnFirstRender : false,
    next: props.next !== undefined ? props.next : function () {},
    fastForward: props.next !== undefined ? props.fastforward : function () {},
    prev: props.prev !== undefined ? props.prev : function () {},
    fastRewind: props.next !== undefined ? props.fastRewind : function () {},

    className: props.className !== undefined ? props.className : ""
  };
};

var Carousel = function (_Component) {
  _inherits(Carousel, _Component);

  function Carousel(props) {
    _classCallCheck(this, Carousel);

    var _this = _possibleConstructorReturn(this, (Carousel.__proto__ || Object.getPrototypeOf(Carousel)).call(this, props));

    (0, _autoBind2.default)(_this);

    _this.state = {
      active: -1,
      prevActive: 0,
      displayed: 0
    };

    _this.timer = null;
    return _this;
  }

  _createClass(Carousel, [{
    key: "componentDidMount",
    value: function componentDidMount() {
      var _sanitizeProps = sanitizeProps(this.props),
          index = _sanitizeProps.index,
          changeOnFirstRender = _sanitizeProps.changeOnFirstRender;

      this.setActive(index, undefined, changeOnFirstRender);

      this.start();
    }
  }, {
    key: "componentWillUnmount",
    value: function componentWillUnmount() {
      this.stop();
    }
  }, {
    key: "componentDidUpdate",
    value: function componentDidUpdate(prevProps, prevState) {
      prevProps = sanitizeProps(prevProps);

      var _sanitizeProps2 = sanitizeProps(this.props),
          autoPlay = _sanitizeProps2.autoPlay,
          interval = _sanitizeProps2.interval,
          children = _sanitizeProps2.children,
          index = _sanitizeProps2.index;

      if (autoPlay !== prevProps.autoPlay || interval !== prevProps.interval) {
        this.reset();
      }

      if (children.length !== prevProps.children.length) {
        this.setActive(index);
      }

      if (prevProps.index !== index) {
        this.setActive(index);
      }
    }
  }, {
    key: "stop",
    value: function stop() {
      if (this.timer) {
        clearInterval(this.timer);
        this.timer = null;
      }
    }
  }, {
    key: "start",
    value: function start() {
      var _sanitizeProps3 = sanitizeProps(this.props),
          autoPlay = _sanitizeProps3.autoPlay,
          interval = _sanitizeProps3.interval;

      if (autoPlay) {
        this.timer = setInterval(this.next, interval);
      }
    }
  }, {
    key: "reset",
    value: function reset() {
      var _sanitizeProps4 = sanitizeProps(this.props),
          autoPlay = _sanitizeProps4.autoPlay;

      this.stop();

      if (autoPlay) {
        this.start();
      }
    }
  }, {
    key: "setActive",
    value: function setActive(index) {
      var _this2 = this;

      var callback = arguments.length > 1 && arguments[1] !== undefined ? arguments[1] : function () {};
      var runCallbacks = arguments.length > 2 && arguments[2] !== undefined ? arguments[2] : true;

      var _sanitizeProps5 = sanitizeProps(this.props),
          onChange = _sanitizeProps5.onChange,
          timeout = _sanitizeProps5.timeout,
          children = _sanitizeProps5.children,
          strictIndexing = _sanitizeProps5.strictIndexing;

      // if index is bigger than the children length, set it to be the last child (if strictIndexing)


      if (Array.isArray(children)) {
        if (strictIndexing && index > children.length - 1) index = children.length - 1;
        if (strictIndexing && index < 0) index = 0;
      } else {
        index = 0;
      }

      var prevActive = this.state.active;

      this.setState({
        active: index,
        prevActive: prevActive,
        displayed: prevActive
      }, this.reset);

      setTimeout(function () {
        _this2.setState({
          displayed: index
        }, function () {
          if (runCallbacks) {
            // Call user defined callbacks
            callback(index, prevActive);
            onChange(index, prevActive);
          }
        });
      }, timeout);
    }
  }, {
    key: "next",
    value: function next(event) {
      var _sanitizeProps6 = sanitizeProps(this.props),
          children = _sanitizeProps6.children,
          next = _sanitizeProps6.next;

      var nextActive = this.state.active + 1 > children.length - 1 ? 0 : this.state.active + 1;

      this.setActive(nextActive, next);
      if (event) event.stopPropagation();
    }
  }, {
    key: "fastforward",
    value: function fastforward(event) {
      var _sanitizeProps7 = sanitizeProps(this.props),
          children = _sanitizeProps7.children,
          fastForward = _sanitizeProps7.fastForward;

      var nextActive = this.state.active + (children.length - this.state.active);

      this.setActive(nextActive, fastForward);

      if (event) event.stopPropagation();
    }
  }, {
    key: "prev",
    value: function prev(event) {
      var _sanitizeProps8 = sanitizeProps(this.props),
          children = _sanitizeProps8.children,
          prev = _sanitizeProps8.prev;

      var nextActive = this.state.active - 1 < 0 ? children.length - 1 : this.state.active - 1;

      this.setActive(nextActive, prev);

      if (event) event.stopPropagation();
    }
  }, {
    key: "fastrewind",
    value: function fastrewind(event) {
      var _sanitizeProps9 = sanitizeProps(this.props),
          children = _sanitizeProps9.children,
          fastRewind = _sanitizeProps9.fastRewind;

      var nextActive = 0;

      this.setActive(nextActive, fastRewind);

      if (event) event.stopPropagation();
    }
  }, {
    key: "render",
    value: function render() {
      var _this3 = this;

      var _sanitizeProps10 = sanitizeProps(this.props),
          children = _sanitizeProps10.children,
          indicators = _sanitizeProps10.indicators,
          navButtonsAlwaysInvisible = _sanitizeProps10.navButtonsAlwaysInvisible,
          navButtonsAlwaysVisible = _sanitizeProps10.navButtonsAlwaysVisible,
          animation = _sanitizeProps10.animation,
          timeout = _sanitizeProps10.timeout,
          fullHeightHover = _sanitizeProps10.fullHeightHover,
          indicatorContainerProps = _sanitizeProps10.indicatorContainerProps,
          indicatorProps = _sanitizeProps10.indicatorProps,
          activeIndicatorProps = _sanitizeProps10.activeIndicatorProps,
          className = _sanitizeProps10.className;

      var classes = this.props.classes;

      var buttonCssClassValue = classes.button + " " + (navButtonsAlwaysVisible ? classes.buttonVisible : classes.buttonHidden) + " " + (fullHeightHover ? classes.fullHeightHoverButton : "");
      var buttonWrapperCssClassValue = classes.buttonWrapper + " " + (fullHeightHover ? classes.fullHeightHoverWrapper : "");

      var compareActiveDisplayed = function compareActiveDisplayed() {
        if (_this3.state.active === 0 && _this3.state.prevActive === children.length - 1) {
          return true;
        }

        if (_this3.state.active === children.length - 1 && _this3.state.prevActive === 0) {
          return false;
        }

        if (_this3.state.active > _this3.state.prevActive) {
          return true;
        }

        return false;
      };

      return _react2.default.createElement(
        "div",
        { className: "" + classes.container },
        _react2.default.createElement(
          "div",
          {
            className: classes.root + " " + (className ? className : ""),
            onMouseEnter: this.stop,
            onMouseOut: this.reset
          },
          Array.isArray(children) ? children.map(function (child, index) {
            return _react2.default.createElement(CarouselItem, {
              key: "carousel-item" + index,
              display: index === _this3.state.displayed ? true : false,
              active: index === _this3.state.active ? true : false,
              isNext: compareActiveDisplayed(),
              child: child,
              animation: animation,
              timeout: timeout,
              next: _this3.next,
              prev: _this3.prev
            });
          }) : _react2.default.createElement(CarouselItem, {
            key: "carousel-item0",
            display: true,
            active: true,
            child: children,
            animation: animation,
            timeout: timeout
            // next={this.next}
            // prev={this.prev}
          }),
          !navButtonsAlwaysInvisible && _react2.default.createElement(
            "div",
            { className: buttonWrapperCssClassValue + " " + classes.next },
            _react2.default.createElement(
              _IconButton2.default,
              {
                className: buttonCssClassValue + " " + classes.next,
                onClick: this.next,
                "aria-label": "Next",
                style: { borderRadius: "5px", padding: "0.5rem 1.2rem" },
                disabled: this.state.active === children.length - 1 ? true : false
              },
              _react2.default.createElement(_PlayArrow2.default, { htmlColor: "#7d7d7d" }),
              " "
            )
          ),
          !navButtonsAlwaysInvisible && _react2.default.createElement(
            "div",
            { className: buttonWrapperCssClassValue + " " + classes.prev + " " },
            _react2.default.createElement(
              _IconButton2.default,
              {
                className: buttonCssClassValue + "  " + classes.prev + " " + classes.playIconReversed,
                onClick: this.prev,
                "aria-label": "Previous",
                style: { borderRadius: "5px", padding: "0.5rem 1.2rem" },
                disabled: this.state.active === 0 ? true : false
              },
              _react2.default.createElement(_PlayArrow2.default, { htmlColor: "#7d7d7d" }),
              " "
            )
          ),
          !navButtonsAlwaysInvisible && _react2.default.createElement(
            "div",
            { className: buttonWrapperCssClassValue + " " + classes.ff + " " },
            _react2.default.createElement(
              _IconButton2.default,
              {
                className: buttonCssClassValue + "  " + classes.ff,
                onClick: this.fastforward,
                "aria-label": "Fast-Forward",
                style: { borderRadius: "5px", padding: "0.5rem 1.2rem" },
                disabled: this.state.active === children.length - 1 ? true : false
              },
              _react2.default.createElement(_FastForward2.default, { htmlColor: "#757575" }),
              " "
            )
          ),
          !navButtonsAlwaysInvisible && _react2.default.createElement(
            "div",
            { className: buttonWrapperCssClassValue + " " + classes.rew + " " },
            _react2.default.createElement(
              _IconButton2.default,
              {
                className: buttonCssClassValue + "  " + classes.rew,
                onClick: this.fastrewind,
                "aria-label": "Fast-Rewind",
                style: { borderRadius: "5px", padding: "0.5rem 1.2rem" },
                disabled: this.state.active === 0 ? true : false
              },
              _react2.default.createElement(_FastRewind2.default, { htmlColor: "#757575" }),
              " "
            )
          ),
          indicators ? _react2.default.createElement(Indicators, {
            classes: classes,
            length: children.length,
            active: this.state.active,
            press: this.setActive,
            indicatorContainerProps: indicatorContainerProps,
            indicatorProps: indicatorProps,
            activeIndicatorProps: activeIndicatorProps
          }) : null
        )
      );
    }
  }]);

  return Carousel;
}(_react.Component);

function CarouselItem(props) {
  var swipeHandlers = (0, _reactSwipeable.useSwipeable)({
    onSwipedLeft: function onSwipedLeft() {
      return props.next();
    },
    onSwipedRight: function onSwipedRight() {
      return props.prev();
    }
  });

  return props.display ? _react2.default.createElement(
    "div",
    _extends({}, swipeHandlers, { className: "CarouselItem" }),
    props.animation === "slide" ? _react2.default.createElement(
      _Slide2.default,
      {
        direction: props.active ? props.isNext ? "left" : "right" : props.isNext ? "right" : "left",
        "in": props.active,
        timeout: props.timeout
      },
      _react2.default.createElement(
        "div",
        null,
        props.child
      )
    ) : _react2.default.createElement(
      _Fade2.default,
      { "in": props.active, timeout: props.timeout },
      _react2.default.createElement(
        "div",
        null,
        props.child
      )
    )
  ) : null;
}

function Indicators(props) {
  var classes = props.classes;

  var indicators = [];

  var _loop = function _loop(i) {
    var style = props.indicatorProps !== undefined ? props.indicatorProps.style : undefined;
    var className = props.indicatorProps !== undefined ? props.indicatorProps.className : undefined;
    var activeStyle = props.activeIndicatorProps !== undefined ? props.activeIndicatorProps.style : undefined;
    var activeClassName = props.activeIndicatorProps !== undefined ? props.activeIndicatorProps.className : undefined;

    className = i === props.active ? classes.indicator + " " + classes.active + " " + activeClassName : classes.indicator + " " + className;

    var item = _react2.default.createElement(_FiberManualRecord2.default, {
      key: i,
      size: "small",
      className: className,
      style: i === props.active ? activeStyle : style,
      onClick: function onClick() {
        props.press(i);
      }
    });

    indicators.push(item);
  };

  for (var i = 0; i < props.length; i++) {
    _loop(i);
  }

  var wrapperStyle = props.indicatorContainerProps !== undefined ? props.indicatorContainerProps.style : undefined;
  var wrapperClassName = props.indicatorContainerProps !== undefined ? props.indicatorContainerProps.className : "";

  return _react2.default.createElement(
    "div",
    {
      className: classes.indicators + " " + wrapperClassName,
      style: wrapperStyle
    },
    indicators
  );
}

// const CarouselContainer = styled.div`
//   display: flex;
//   justify-content: center;
//   align-items: center;
//   width: 70vw;
//   height: 300px;
//   background-color: #e0e0e0;
// `;
// const CustomButton = styled(Button)`
//   padding: 0.4rem 1.2rem;
//   position: absolute;
//   border-radius: 5px;
//   display: flex;
//   background-color: #e0e0e0;
//   border: 1px solid transparent;
// `;
// const Backward = styled(CustomButton)`
//   left: -11.5%;
//   top: -12%;
// `;
// const Forward = styled(CustomButton)`
//   right: -11.5%;
//   top: -12%;
// `;
// const FastRewind = styled(CustomButton)`
//   left: -5.8%;
//   top: -12%;
// `;
// const FastForward = styled(CustomButton)`
//   right: -5.8%;
//   top: -12%;
// `;
// const StyledPlayArrowIcon = styled(PlayArrowIcon)`
//   transform: rotate(180deg);
// `;
exports.default = (0, _styles.withStyles)(styles)(Carousel);